Attribute VB_Name = "MTimer"
' ------------------------------------------------------------------------
'    Copyright  1999 Willamette Industries, Inc.  All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' this source code (and/or any modified version) in any way you find
' useful, provided that you agree that Willamette Industries has no
' warranty, obligations or liability for any use of this code.
'
' Written April 15, 1999 by Darryl Luther
' ------------------------------------------------------------------------
Option Explicit

Declare Function SetTimer Lib "user32" _
    ( _
      ByVal hWnd As Long, _
      ByVal nIDEvent As Long, _
      ByVal uElapse As Long, _
      ByVal lpTimerFunc As Long _
    ) _
  As Long
  
Declare Function KillTimer Lib "user32" _
    ( _
      ByVal hWnd As Long, _
      ByVal nIDEvent As Long _
    ) _
  As Long

Private mhTimer As Long
Private mobjTimerObject As CNotifier

Public Sub StartTimer(objCallingObject As CNotifier, lDelay As Long)
  'This sets the object reference to the class object
  Set mobjTimerObject = objCallingObject
  'This API function returns the handle to the timer.  The first
  '2 parameters should always be zero, the third is the timer
  'interval in milliseconds (1000 mSec = 1 Sec), and the fourth
  'parameter is a pointer to the callback function (use AddressOf
  'to get a pointer in VB).  This function will be called each time
  'the API Timer fires.
  mhTimer = SetTimer(0, 0, lDelay, AddressOf TimerProc)
End Sub

'This is the function which will be called every time the API Timer
'fires.  It's very important the parameters be exactly as they are
'here or you'll get strange results or even GPF's.
Public Sub TimerProc(ByVal hWnd As Long, ByVal msg As Long, _
                     ByVal id As Long, ByVal currentime As Long)
  'The timer will continue to fire at regular intervals unless it
  'is ended.  An API Timer is ended by passing it's handle to the
  'KillTimer API function.
  Call KillTimer(0, mhTimer)
  'While not necessary, cleaning up your objects and handles is
  'always a good idea...
  mhTimer = 0
  'Call the method in CNotifier to start the process you want to
  'run asynchronously.
  mobjTimerObject.KickOff
  'Release this instance of the clsInterface object or the ActiveX
  'EXE will never be removed from memory until you shut down the PC
  'or use Ctrl-Alt-Del to end the process.
  Set mobjTimerObject = Nothing
End Sub
